
local gamera = require "gamera"
local cam

function love.load()
    -- load image
    img = love.graphics.newImage("map.png")

    -- create gamera object
    cam = gamera.new(0, 0, 800, 600)

    -- player position
    player_pos = {x = 0, y = 0}
end

function love.update(dt)
    local speed = 200
    -- move
    if love.keyboard.isDown("w") then
        player_pos.y = player_pos.y - speed * dt
    end
    if love.keyboard.isDown("s") then
        player_pos.y = player_pos.y + speed * dt
    end
    if love.keyboard.isDown("a") then
        player_pos.x = player_pos.x - speed * dt
    end
    if love.keyboard.isDown("d") then
        player_pos.x = player_pos.x + speed * dt
    end
end

function love.draw()
    -- fill background
    love.graphics.setColor(15, 170, 220, 255)
    love.graphics.rectangle("fill", -30, -380, 3800, 3600)

    local draw_f = function (l, t, w, h)

        -- draw map
        love.graphics.clear()
        love.graphics.setColor(255, 255, 255, 255)
        love.graphics.draw(img, 0, 0)

        -- draw player
        love.graphics.setColor(250, 0, 0)
        love.graphics.circle("fill", player_pos.x, player_pos.y, 30)
        love.graphics.setColor(0, 250, 0)
        love.graphics.circle("fill", player_pos.x, player_pos.y, 10)
    end

    if true then
        cam:setWorld(0, 0, 1800, 800)
        cam:setWindow(10, 10, 400, 400)
        cam:setPosition(player_pos.x, player_pos.y)
        cam:setScale(2)
        cam:draw(draw_f)
    --else
        cam:setWindow(500, 10, 200, 200)
        cam:setPosition(player_pos.x, player_pos.y)
        cam:setWorld(0,0, 400, 400)
        cam:setScale(1)
        cam:draw(draw_f)
    end

    love.graphics.setColor(0, 0, 0, 255)
    love.graphics.print("left", 0,0)
    love.graphics.print("right", 500,0)
end

return run
